/*********************************************************************
 * DateIuWFNg֘ÃCu
 * -------------------------------------------------------------------
 * 2008/02/22 VK쐬
 * 2009/11/30 `֐ǉ
 * 2009/12/03 oOC
 * 2012/09/14 RFC822`Ő`֐ǉB[lߊ֐ǉɔ֐ύX
 * -------------------------------------------------------------------
 * Copyright(C) 2008-2012 ASANO Sei (http://sei.qee.jp/docs/)
 *********************************************************************/
//**Start Encode**
Date.prototype.nameConsts = {
	month : {
		en : {
			short : ['Jan','Feb','Mar','Apr','May','Jun','Jul','Aug','Sep','Oct','Nov','Dec']
		}
	}
	, day : {
		en : {
			short : ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat']
		}
		//,jp : ['', '', '', '', '', '', 'y']
	}
}
/*********************************************************************
 * ێĂť̓Ԃ
 * -------------------------------------------------------------------
 * [] Ȃ
 * [߂] ێĂť̓
 *********************************************************************/
Date.prototype.getMonthDays = function() {
	//Ƀ[ƑO̍ŏI擾ł̂𗘗p
	return new Date(this.getYear(), this.getMonth()+1, 0).getDate();
}
/*********************************************************************
 * N YYYY/MM/DD `Ő`ĕԂ
 * -------------------------------------------------------------------
 * [] Ȃ
 * [߂] YYYY/MM/DD `Ő`N
 *********************************************************************/
Date.prototype.toYYYYMMDD = function() {
	var mm = this.getMonth() + 1;
	var dd = this.getDate();
	return this.getFullYear() + "/"
		+ this.paddingZeroMax2(mm) + "/"
		+ this.paddingZeroMax2(dd);
}
/*********************************************************************
 *  HH:MN:SS `Ő`ĕԂ
 * -------------------------------------------------------------------
 * [] Ȃ
 * [߂] HH:MN:SS `Ő`
 *********************************************************************/
Date.prototype.toHHMNSS = function() {
	var hh = this.getHours();
	var mn = this.getMinutes();
	var ss = this.getSeconds();
	return this.paddingZeroMax2(hh) + ":"
		+ this.paddingZeroMax2(mn) + ":"
		+ this.paddingZeroMax2(ss);
}
/*********************************************************************
 *  HH:MN:SS.MS `Ő`ĕԂ
 * -------------------------------------------------------------------
 * [] Ȃ
 * [߂] HH:MN:SS.MS `Ő`
 *********************************************************************/
Date.prototype.toHHMNSSMS = function() {
	var hh = this.getHours();
	var mn = this.getMinutes();
	var ss = this.getSeconds();
	var ms = this.getMilliseconds();
	return this.paddingZeroMax2(hh) + ":"
		+ this.paddingZeroMax2(mn) + ":"
		+ this.paddingZeroMax2(ss) + "."
		+ ms;
}
/*********************************************************************
 * YYYY/MM/DD HH:MN:SS `Ő`ĕԂ
 * -------------------------------------------------------------------
 * [] Ȃ
 * [߂] YYYY/MM/DD HH:MN:SS `Ő`
 *********************************************************************/
Date.prototype.toYYYYMMDD_HHMNSS = function() {
	return this.toYYYYMMDD() + " " + this.toHHMNSS();
}
/*********************************************************************
 * YYYY/MM/DD HH:MN:SS.MS `Ő`ĕԂ
 * -------------------------------------------------------------------
 * [] Ȃ
 * [߂] YYYY/MM/DD HH:MN:SS.MS `Ő`
 *********************************************************************/
Date.prototype.toYYYYMMDD_HHMNSSMS = function() {
	return this.toYYYYMMDD() + " " + this.toHHMNSSMS();
}
/*********************************************************************
 * RFC822`Ő`ĕԂ
 * -------------------------------------------------------------------
 * [] Ȃ
 * [߂] RFC822`Ő`
 *********************************************************************/
Date.prototype.toRFC822 = function() {
	return this.nameConsts.day.en.short[this.getDay()] + ', '
		+ this.paddingZeroMax2(this.getDate()) + ' '
		+ this.nameConsts.month.en.short[this.getMonth()] + ' '
		+ this.getFullYear() + ' '
		+ this.paddingZeroMax2(this.getHours()) + ':'
		+ this.paddingZeroMax2(this.getMinutes()) + ':'
		+ this.paddingZeroMax2(this.getSeconds()) + ' '
		+ '+0900';
}
/*********************************************************************
 * 1̐2Ƀ[l߂ԂB2ȏȂ炻̂܂ܕԂB
 * -------------------------------------------------------------------
 * [] int : 
 * [߂] [l߂čŒ2ɂl
 *********************************************************************/
Date.prototype.paddingZeroMax2 = function(int) {
	return (int < 10 ? '0' + int : int);
}
