/*********************************************************************
 * Excel֘ACu
 *  FileSystem.js K{
 * -------------------------------------------------------------------
 * 2008/ 2/20 ver 1.0 VK쐬
 * 2008/ 2/21 ver 1.1 ӂɂȂ悤Aړt
 * 2009/ 1/28 ver 1.2 F`ǉ
 * 2010/ 3/ 4 ver 1.2.1 F`ǉ(6:F)
 * 2010/ 7/12 ver 1.3 č쐬irj
 *********************************************************************/
//**Start Encode**
var excel = {
	application : null
}
/*********************************************************************
 * \ExcelIuWFNgԂBɃIuWFNg΁A
 * IuWFNgAȂΐĕԂB
 * -------------------------------------------------------------------
 * []
 *   Ȃ
 * [߂]
 *   \ExcelIuWFNgB擾łȂꍇnull
 *********************************************************************/
function excel_getApplication() {
	if (excel.application) {
		try {
			excel.application.Visible; //IuWFNgLmF
			return excel.application;
		} catch(e) {
			excel.application = null;
		}
	}
	try {
		excel.application = new ActiveXObject("Excel.Application");
		excel.application.Visible = false; //ftHgfalseȂ̂ŕKvȂ낤ǔÔ
	} catch(e) {
		excel.application = null;
	} finally {
		return excel.application;
	}
}
/*********************************************************************
 * CӂExcelIuWFNgI
 * -------------------------------------------------------------------
 * [] obj : ExcelIuWFNg
 * [߂] Ȃ
 *********************************************************************/
function excel_quitApplication(obj) {
	if (!obj) return;
	try {
		obj.Quit();
	} catch(e) {
		//Ȃ
	}
}
/*********************************************************************
 * ExcelIuWFNgI
 * -------------------------------------------------------------------
 * [] Ȃ
 * [߂] Ȃ
 *********************************************************************/
function excel_quit() {
	excel_quitApplication(excel.application);
}
/*********************************************************************
 * t@CI_CAOJB
 * -------------------------------------------------------------------
 * [] title: _CAÕ^Cg
 *        filter: gqtB^
 *        filterIndex: tB^̃CfbNXBŏl1
 * [߂] Iꂽt@CBLZnullAG[undefined
 *********************************************************************/
function excel_openDialog(title, filter, filterIndex) {
	var app = excel_getApplication();
	if (!app) return undefined;
	var loadFileName = app.getOpenFilename(filter, filterIndex, title);
	if (!loadFileName) return null; //LZꂽ
	return loadFileName;
}
/*********************************************************************
 * Oĕۑ_CAOJB
 * -------------------------------------------------------------------
 * [] dir : \fBNg
 *        title: _CAÕ^Cg
 *        filter: gqtB^
 *        filterIndex: tB^̃CfbNXBŏl1
 * [߂] w肳ꂽt@CBLZnullAG[undefined
 *********************************************************************/
function excel_saveDialog(dir, title, filter, filterIndex) {
	var app = excel_getApplication();
	if (!app) return undefined;
	var saveFileName = app.getSaveAsFilename(dir, filter, filterIndex, title);
	if (!saveFileName) return null; //LZꂽ
	return saveFileName;
}
/*********************************************************************
 * ExcelubNt@CۑB̃t@C݂ꍇ͖
 * uB
 * -------------------------------------------------------------------
 * [] book: ExcelubNIuWFNg
 *        filePath: ۑt@CitpXj
 * [߂] ۑnullAs̓G[bZ[W
 *********************************************************************/
function excel_saveBookFileOverwrite(book, filePath) {
	var deleteOk = fileSystem_deleteFileIfExists(filePath);
	if (deleteOk) {
		try {
			book.SaveAs(filePath);
			return null;
		} catch(e) {
			return common_getExceptionText(e);
		}
	} else {
		return "ExcelubNt@Cƒuł܂łB";
	}
}


//***************************************************
var EXCEL_WBA_TEMPLATE_CHART = -4109;
var EXCEL_WBA_TEMPLATE_WORKSHEET = -4167;
var EXCEL_WBA_TEMPLATE_EXCEL4MACROSHEET = 3;
var EXCEL_WBA_TEMPLATE_EXCEL4INTLMACROSHEET =4;

var EXCEL_ADDRESS_R1C1 = -4150;
var EXCEL_ADDRESS_A1 = 1;

var EXCEL_CELL_TYPE_LAST_CELL = 11;

var EXCEL_OBJECT_TEXT_BOX = 11;

var EXCEL_PATTERN_SOLID = 1;

var EXCEL_COLOR_INDEX_NONE = -4142;
var EXCEL_COLOR_INDEX_AUTOMATIC = -4105;

var EXCEL_COLOR_INDEX_BLACK = 1;
var EXCEL_COLOR_INDEX_WHITE = 2;
var EXCEL_COLOR_INDEX_RED = 3;
var EXCEL_COLOR_INDEX_BLUE = 5;
var EXCEL_COLOR_INDEX_YELLOW = 6;
var EXCEL_COLOR_INDEX_LIGHT_GRAY = 15;
var EXCEL_COLOR_INDEX_LIGHT_BLUE = 24;
var EXCEL_COLOR_INDEX_LIGHT_ORANGE = 40;
var EXCEL_COLOR_INDEX_GREEN = 43;
var EXCEL_COLOR_INDEX_DARK_GREEN = 43; //del\
var EXCEL_COLOR_INDEX_LIGHT_GREEN = 35;
var EXCEL_COLOR_INDEX_AUTOMATIC = -4105;

var EXCEL_NONE = -4142;
var EXCEL_DIAGONAL_DOWN = 5;
var EXCEL_DIAGONAL_UP = 6;
var EXCEL_EDGE_LEFT = 7;
var EXCEL_EDGE_TOP = 8;
var EXCEL_EDGE_BOTTOM = 9;
var EXCEL_EDGE_RIGHT = 10;
var EXCEL_BORDERS_INDEX_EDGE_LEFT = 7;
var EXCEL_BORDERS_INDEX_EDGE_TOP = 8;
var EXCEL_BORDERS_INDEX_EDGE_BOTTOM = 9;
var EXCEL_BORDERS_INDEX_EDGE_RIGHT = 10;

var EXCEL_BORDERS_WEIGHT_THIN = 2;

var EXCEL_LINE_STYLE_CONTINUOUS = 1;

function excel_fillBackGroundColor(range, colorIndex) {
	range.Interior.ColorIndex = colorIndex;
	range.Interior.Pattern = EXCEL_PATTERN_SOLID;
	range.Interior.PatternColorIndex = EXCEL_COLOR_INDEX_AUTOMATIC;
}
function excel_drowBorder(range, bordersIndex) {
	range.Borders(bordersIndex).LineStyle = EXCEL_LINE_STYLE_CONTINUOUS;
	range.Borders(bordersIndex).Weight = EXCEL_BORDERS_WEIGHT_THIN;
	range.Borders(bordersIndex).ColorIndex = EXCEL_COLOR_INDEX_AUTOMATIC;
}
function excel_drowBorderSqure(range, colorIndex) {
	excel_drowBorder(range, EXCEL_EDGE_LEFT);
	excel_drowBorder(range, EXCEL_EDGE_TOP);
	excel_drowBorder(range, EXCEL_EDGE_BOTTOM);
	excel_drowBorder(range, EXCEL_EDGE_RIGHT);
	range.Borders(EXCEL_EDGE_LEFT).ColorIndex = colorIndex;
	range.Borders(EXCEL_EDGE_TOP).ColorIndex = colorIndex;
	range.Borders(EXCEL_EDGE_BOTTOM).ColorIndex = colorIndex;
	range.Borders(EXCEL_EDGE_RIGHT).ColorIndex = colorIndex;

}
