/*********************************************************************
 * FileSystemObject֘ÃCu
 *  Common.js K{
 *  Date.js   K{
 * -------------------------------------------------------------------
 * 2008/02/20 VK쐬
 * 2008/02/21 ӂɂȂ悤ړt
 * 2010/07/12 DictionarỹeLXgt@Co͊֐ǉ
 * 2012/11/08 fileSystem_writeArray֐ǉ
 *            t@Co̗͂OAOt@CΓeo͂悤ύX
 * -------------------------------------------------------------------
 * Copyright(C) 2008 ASANO, Sei (http://sei.qee.jp/docs/)
 *********************************************************************/
//**Start Encode**
var fileSystem = {
	ioMode : {
		 ForReading  : 1 //ǂݎp
		,ForWriting  : 2 //ݐp
		,ForAppending: 8 //ǉ
	}
	,format : {
		 TristateUseDefault: -2 //VXeftHgŃI[v
		,TristateTrue  : -1 //Unicodet@CƂăI[v
		,TristateFalse : 0  //ASCIIt@CƂăI[v
	}
	,separator : {
		 FILE : "."  //t@C̃x[XƊgq؂镶
		,PATH : "\\" //pX؂镶
	}
	,fso : null
	,scriptFileName : { base : "", full : "", dir : "" }
	,log    : { EXT : "log",    fileName : "", file : null, text : null }
	,config : { EXT : "config", fileName : "", data : null }
}
fileSystem_initialize();
/*********************************************************************
 * ݒ菈
 * -------------------------------------------------------------------
 * [] Ȃ
 * [߂] Ȃ
 *********************************************************************/
function fileSystem_initialize() {
	fileSystem.fso = new ActiveXObject("Scripting.FileSystemObject");
	fileSystem.scriptFileName.full = fileSystem_getScriptFullName();
	fileSystem.scriptFileName.base = fileSystem.fso.GetBaseName(fileSystem.scriptFileName.full);
	fileSystem.scriptFileName.dir = fileSystem.scriptFileName.full.substr(0, fileSystem.scriptFileName.full.lastIndexOf("\\"));
	fileSystem.log.fileName = fileSystem_changeExtension(fileSystem.scriptFileName.full, fileSystem.log.EXT);
	fileSystem.config.fileName = fileSystem_changeExtension(fileSystem.scriptFileName.full, fileSystem.config.EXT);
}
// sXNvg̃pXt@CԂ
function fileSystem_getScriptFullName() {
	if (common.isWsh) {
		return WScript.ScriptFullName;
	} else if (common.isHta) {
		return unescape(window.location.pathname);
	}
}
/*********************************************************************
 * Ot@C̏
 *********************************************************************/
// Ot@CI[vAJnbZ[Ws
function fileSystem_startLogFile() {
	fileSystem.log.file = fileSystem.fso.OpenTextFile(fileSystem.log.fileName, fileSystem.ioMode.ForWriting, true);
	fileSystem_writeLineLogFile("[" + fileSystem.scriptFileName.base + "]");
	fileSystem_writeLineLogFile("***** Start (" + new Date().toYYYYMMDD_HHMNSS() + ") *****");
	fileSystem_writeLineLogFile("");
}
// Ot@CɃbZ[Wǉ (msg: bZ[W)
function fileSystem_writeLogFile(msg) {
	fileSystem.log.file.Write(msg);
}
// Ot@CɃbZ[Wsǉ (msg: bZ[W)
function fileSystem_writeLineLogFile(msg) {
	fileSystem.log.file.WriteLine(msg);
}
// Ot@CErrorIuWFNg̃R[hƓe̍sǉ (e: ErrorIuWFNgAdesc: Cӂ̐Bȗ)
function fileSystem_writeLineLogFileForException(e, desc) {
	if (!fileSystem.log.file) return;
	fileSystem.log.file.WriteLine(
		(common_isEmpty(desc) ? "" : desc + "\t")
		+ common_getExceptionText(e)
	);
}
// Ot@CɏIbZ[WsŃN[Y
function fileSystem_closeLogFile() {
	fileSystem_writeLineLogFile("");
	fileSystem_writeLineLogFile("***** End (" + new Date().toYYYYMMDD_HHMNSS() + ") *****");
	fileSystem.log.file.Close();
	fileSystem.log = null;
}
/*********************************************************************
 * Ot@C̏iStringŁj
 *********************************************************************/
// OZbg
function fileSystem_resetLogText() {
	fileSystem.log.text = '';
}
// OɃbZ[Wǉ (msg: bZ[W)
function fileSystem_writeLogText(msg) {
	fileSystem.log.text += msg;
}
// OɃbZ[Wsǉ (msg: bZ[W)
function fileSystem_writeLineLogText(msg) {
	fileSystem_writeLogText(msg + '\r\n');
}
// OɊJnbZ[Wsݒ肷
function fileSystem_startLogText() {
	fileSystem_resetLogText();
	fileSystem_writeLineLogText('[' + fileSystem.scriptFileName.base + ']');
	fileSystem_writeLineLogText('');
	fileSystem_writeLineLogText('***** Start (' + new Date().toYYYYMMDD_HHMNSS() + ') *****');
	fileSystem_writeLineLogText('');
}
// OErrorIuWFNg̃R[hƓe̍sǉ (e: ErrorIuWFNgAdesc: Cӂ̐Bȗ)
function fileSystem_writeLineLogTextForException(e, desc) {
	fileSystem_writeLineLogText(
		(common_isEmpty(desc) ? '' : desc + '\t')
		+ common_getExceptionText(e)
	);
}
// OɏIbZ[Wsǉăt@Cɕۑi߂lȂj
// ̃Ot@Cɏ߂Ȃ΁A݂̓suffixɂt@Cɏo͂i߂l̓t@Cj
function fileSystem_saveLogText() {
	fileSystem_writeLineLogText('')
	fileSystem_writeLineLogText('***** End (' + new Date().toYYYYMMDD_HHMNSS() + ') *****')
	try {
		fileSystem.log.file = fileSystem.fso.OpenTextFile(fileSystem.log.fileName, fileSystem.ioMode.ForWriting, true);
		fileSystem.log.file.Write(fileSystem.log.text);
	} catch(e) {
		var tempLogFileName = fileSystem.log.fileName + '.' + new Date().valueOf();
		fileSystem.log.file = fileSystem.fso.OpenTextFile(tempLogFileName, fileSystem.ioMode.ForWriting, true);
		fileSystem.log.file.Write(fileSystem.log.text);
		return tempLogFileName;
	} finally {
		if (fileSystem.log.file) fileSystem.log.file.Close();
		fileSystem_resetLogText();
	}
}
/*********************************************************************
 * gqύXt@CԂBt@C[̕A
 * nullAundefined ̏ꍇ͒[̕ԂB
 * Vgq[̕AnullAundefined ̏ꍇ́AgqȂ
 * t@CԂB
 * -------------------------------------------------------------------
 * [] fileName: t@C
 *        newExt:   Vgq
 * [߂] gqVgqɕύXt@C
 *********************************************************************/
function fileSystem_changeExtension(fileName, newExt) {
	if (common_isEmpty(fileName)) return "";
	var baseName = fileName.slice(0, fileName.lastIndexOf(fileSystem.separator.FILE));
	if (common_isEmpty(newExt)) return baseName;
	return baseName + fileSystem.separator.FILE + newExt;
}
/*********************************************************************
 * esAL[A^uAlAō\ꂽeLXgt@Cǂݍ݁A
 * DictionaryIuWFNgɊi[ĕԂB
 * ̂Ƃw肳ꂽ̓t@CȂ΍쐬B
 * Ȃ1ڂ#̂s̓RgƌȂĖAsiŝ݂̍sj
 * B
 * -------------------------------------------------------------------
 * [] fileName: ̓t@C
 *        noMake : t@C쐬Ȃꍇtrue
 * [߂] DictionaryIuWFNg
 *********************************************************************/
function fileSystem_readProperties(fileName, noMake) {
	var properties = new ActiveXObject("Scripting.Dictionary");
	if (fileSystem.fso.FileExists(fileName)) {
		var stream;
		var line;
		try {
			stream = fileSystem.fso.GetFile(fileName).OpenAsTextStream(
				fileSystem.ioMode.ForReading,
				fileSystem.ioMode.TristateFalse
			);
			var lineArray, key;
			while (!stream.AtEndOfStream) {
				line = stream.ReadLine();
				if ((line == "")||(line.substr(0,1) == "#")) continue;
				lineArray = line.split("\t");
				key = lineArray.shift();
				if (!properties.Exists(key)) properties.Add(key, lineArray.join("\t"));
			}
		} catch(e) {
			if (fileSystem.log.file) {
				fileSystem_writeLineLogFile(fileName);
				fileSystem_writeLineLogFileForException(e);
			}
		} finally {
			if (stream) stream.Close();
		}
	} else {
		if (!noMake) fileSystem.fso.CreateTextFile(fileName);
	}
	return properties;
}
/*********************************************************************
 * esAL[A^uAlAō\ꂽeLXgt@Cǂݍ݁A
 * L[͊es̐擪vfAl͊es̎c̗vfzɊi[̂A
 * DictionaryIuWFNgɊi[ĕԂB
 * ̂Ƃw肳ꂽ̓t@CȂ΍쐬B
 * Ȃ1ڂ#̂s̓RgƌȂĖAsiŝ݂̍sj
 * B
 * -------------------------------------------------------------------
 * [] fileName: ̓t@C
 * [߂] DictionaryIuWFNg
 *********************************************************************/
function fileSystem_readSeparatedTabTextWithKey(fileName) {
	var properties = new ActiveXObject("Scripting.Dictionary");
	if (fileSystem.fso.FileExists(fileName)) {
		var stream;
		var line;
		try {
			stream = fileSystem.fso.GetFile(fileName).OpenAsTextStream(
				fileSystem.ioMode.ForReading,
				fileSystem.ioMode.TristateFalse
			);
			var lineArray, key;
			while (!stream.AtEndOfStream) {
				line = stream.ReadLine();
				if ((line == "")||(line.substr(0,1) == "#")) continue;
				lineArray = line.split("\t");
				if (lineArray.length == 0) continue;
				key = lineArray.shift();
				if (!properties.Exists(key)) properties.Add(key, lineArray);
			}
		} catch(e) {
			if (fileSystem.log.file) {
				fileSystem_writeLineLogFile(fileName);
				fileSystem_writeLineLogFileForException(e);
			}
		} finally {
			if (stream) stream.Close();
		}
	} else {
		fileSystem.fso.CreateTextFile(fileName);
	}
	return properties;
}
/*********************************************************************
 * eLXgt@Cǂݍ݁AesvfƂzɊi[ĕԂB
 * ̂Ƃw肳ꂽ̓t@CȂ΍쐬B
 * -------------------------------------------------------------------
 * [] fileName: ̓t@C
 *        noMake : t@C쐬Ȃꍇtrue
 * [߂] ArrayIuWFNg
 *********************************************************************/
function fileSystem_readPlainText(fileName, noMake) {
	var array = new Array();
	if (fileSystem.fso.FileExists(fileName)) {
		var stream;
		try {
			stream = fileSystem.fso.GetFile(fileName).OpenAsTextStream(
				fileSystem.ioMode.ForReading,
				fileSystem.ioMode.TristateFalse
			);
			while (!stream.AtEndOfStream) {
				array.push(stream.ReadLine());
			}
		} catch(e) {
			if (fileSystem.log.file) {
				fileSystem_writeLineLogFile(fileName);
				fileSystem_writeLineLogFileForException(e);
			}
		} finally {
			if (stream) stream.Close();
		}
	} else {
		if (!noMake) fileSystem.fso.CreateTextFile(fileName);
	}
	return array;
}
/*********************************************************************
 * eLXgt@Cǂݍ݁AesvfƂzɊi[ĕԂB
 * ̂Ƃw肳ꂽ̓t@CȂ΍쐬B
 * Ȃ1ڂ#̂s̓RgƌȂĖAsiŝ݂̍sj
 * Bds͍폜B
 * -------------------------------------------------------------------
 * [] fileName: ̓t@C
 * [߂] ArrayIuWFNg
 *********************************************************************/
function fileSystem_readPlainTextSet(fileName) {
	var properties = new ActiveXObject("Scripting.Dictionary");
	var array = new Array();
	if (fileSystem.fso.FileExists(fileName)) {
		var stream;
		var line;
		try {
			stream = fileSystem.fso.GetFile(fileName).OpenAsTextStream(
				fileSystem.ioMode.ForReading,
				fileSystem.ioMode.TristateFalse
			);
			while (!stream.AtEndOfStream) {
				line = stream.ReadLine();
				if ((line == "")||(line.substr(0,1) == "#")) continue;
				if (!properties.Exists(line)) {
					properties.Add(line, null);
					array.push(line);
				}
			}
		} catch(e) {
			if (fileSystem.log.file) {
				fileSystem_writeLineLogFile(fileName);
				fileSystem_writeLineLogFileForException(e);
			}
		} finally {
			if (stream) stream.Close();
		}
	} else {
		fileSystem.fso.CreateTextFile(fileName);
	}
	return array;
}
/*********************************************************************
 * DictionaryIuWFNg̓eA
 * esAL[A^uAlAō\ꂽeLXgf[^Ƃăt@C
 * o͂B
 * -------------------------------------------------------------------
 * [] fileName:   o̓t@C
 *        properties: DictionaryIuWFNg
 * [߂] Ȃ
 *********************************************************************/
function fileSystem_writeProperties(fileName, properties) {
	var stream;
	try {
		if (!fileSystem.fso.FileExists(fileName)) fileSystem.fso.CreateTextFile(fileName);
		stream = fileSystem.fso.GetFile(fileName).OpenAsTextStream(
				fileSystem.ioMode.ForWriting,
				fileSystem.ioMode.TristateFalse
		);
		var keys = properties.Keys().toArray();
		for (var i=0 ; i<keys.length ; i++) {
			stream.WriteLine(keys[i] + "\t" + properties.Item(keys[i]));
		}
	} catch(e) {
		if (fileSystem.log.file) {
			fileSystem_writeLineLogFile(fileName);
			fileSystem_writeLineLogFileForException(e);
		}
	} finally {
		if (stream) stream.Close();
	}
}
/*********************************************************************
 * Stringz̓eAevfsƂeLXgt@Cɏo͂B
 * -------------------------------------------------------------------
 * [] fileName: o̓t@C
 *        array:    Stringz
 * [߂] Ȃ
 *********************************************************************/
function fileSystem_writeArray(fileName, array) {
	var stream;
	try {
		if (!fileSystem.fso.FileExists(fileName)) fileSystem.fso.CreateTextFile(fileName);
		stream = fileSystem.fso.GetFile(fileName).OpenAsTextStream(
				fileSystem.ioMode.ForWriting,
				fileSystem.ioMode.TristateFalse
		);
		for (var i=0 ; i<array.length ; i++) {
			stream.WriteLine(array[i]);
		}
	} catch(e) {
		if (fileSystem.log.file) {
			fileSystem_writeLineLogFile(fileName);
			fileSystem_writeLineLogFileForException(e);
		}
	} finally {
		if (stream) stream.Close();
	}
}
/*********************************************************************
 * String̓eeLXgt@Cɏo͂B
 * -------------------------------------------------------------------
 * [] fileName: o̓t@C
 *        text:    String
 * [߂] Ȃ
 *********************************************************************/
function fileSystem_writePlainText(fileName, text) {
	var stream;
	try {
		if (!fileSystem.fso.FileExists(fileName)) fileSystem.fso.CreateTextFile(fileName);
		stream = fileSystem.fso.GetFile(fileName).OpenAsTextStream(
				fileSystem.ioMode.ForWriting,
				fileSystem.ioMode.TristateFalse
		);
		stream.Write(text);
	} catch(e) {
		if (fileSystem.log.file) {
			fileSystem_writeLineLogFile(fileName);
			fileSystem_writeLineLogFileForException(e);
		}
	} finally {
		if (stream) stream.Close();
	}
}
/*********************************************************************
 * tH_쐬BetH_Ȃ΁AoĤׂẴtH_
 * ċAIɍ쐬B
 * -------------------------------------------------------------------
 * [] folderPath: 쐬tH_̃pX
 * [߂] Ȃ
 *********************************************************************/
function fileSystem_createAllFolder(folderPath) {
	var parentFolder = fileSystem.fso.GetParentFolderName(folderPath);
	if (!fileSystem.fso.FolderExists(folderPath)) {
		fileSystem_createAllFolder(parentFolder);
	}
	fileSystem_createFolderInNotExists(folderPath);
}
/*********************************************************************
 * w肳ꂽtH_ԂBȂ΍쐬ĕԂB
 * etH_݂͑Ă̂ƂB
 * -------------------------------------------------------------------
 * [] folderPath: tH_pX
 * [߂] FolderIuWFNg
 *********************************************************************/
function fileSystem_getFolder(folderPath) {
	if (!fileSystem_createFolderInNotExists(folderPath)) return null;
	return fileSystem.fso.GetFolder(folderPath);
}
/*********************************************************************
 * tH_݂ĂȂ΍쐬B
 * etH_݂͑Ă̂ƂB
 * -------------------------------------------------------------------
 * [] folderPath: tH_pX
 * [߂] true: Afalse: s
 *********************************************************************/
function fileSystem_createFolderInNotExists(folderPath) {
	if (!fileSystem.fso.FolderExists(folderPath)) {
		try {
			fileSystem.fso.CreateFolder(folderPath);
		} catch(e) {
			return false;
		}
	}
	return true;
}
/*********************************************************************
 * t@C݂폜B
 * -------------------------------------------------------------------
 * [] fileName: 폜t@C̃tpX
 * [߂] true:  t@C݂ȂA܂͍폜ꍇ
 *        false: t@C폜łȂꍇ
 *********************************************************************/
function fileSystem_deleteFileIfExists(fileName) {
	if (!fileSystem.fso.FileExists(fileName)) return true;
	try {
		fileSystem.fso.DeleteFile(fileName, true); //ǂݎpt@C폜
		return true;
	} catch(e) {
		return false;
	}
}
